#include <LiquidCrystal.h>
#include <OneWire.h>

int butPin = 0;            // вход кнопок
int buzzer = 5;            // выход динамика
int exitMenu = 1;          // выход из меню
int butPush = 0;           // код нажатой кнопки
int butRel=1;              // нажата ли сейчас кнопка
int val;                   // знач. АЦП при нажатой кнопке
int menu=0;                // текущий экран
int port1=3;               // порт на котором висит нагрузка
byte port1_stat=0;         // статус порта (включен/выключен
byte i;                    // счетчик
byte n;                    // счетчик
float T;                   // переменная для хранения температуры
byte data[8];              // для хранения данных от датчика
unsigned long timer=0;     // таймер 
unsigned long procStTime=0;// время начала текущего процесса
unsigned long StTime=0;    // время запуска программы
float T1=52;               // начальные значения температур и ...
float T2=63; 
float T3=74;
float T4=78;
int P1=20;                 // ... пауз в минутах
int P2=40;
int P3=30;
int P4=4;
int process=0;             // номер текущего процесса
boolean running = false;   // состояние программы

OneWire  ds(7);            // на этот пин подключен DS
LiquidCrystal lcd(13, 12, 11, 10, 9, 8); //инициализация LCD

void setup()
{
  lcd.begin(2, 16);
  Serial.begin(9600);
  pinMode(port1, OUTPUT);
  pinMode(buzzer, OUTPUT);
  tone(buzzer, 1000);
}

void loop()
{
 
    ds.reset();
    ds.write(0xCC,1);          // пропуск ROM
    ds.write(0x44,1);          // запускаем конвертацию
    for( n = 1; n < 90; n++) { //ждем 900 мс
    delay(10);            
    if (analogRead(butPin) > 100) { Menu(button ()); } //периодически проверяя не нажата ли кнопка
    }
    ds.reset();
    ds.write(0xCC,1);           // пропуск ROM
    ds.write(0xBE);             // считываем ОЗУ датчика
    for ( i = 0; i < 9; i++) {  // обрабатываем 9 байт
    data[i] = ds.read();
     }

    T = float((data[1] << 8) + data[0])/16;     // высчитываем температуру :)
    if (T > 84) {T=0;}           // это для того, чтобы при глюке датчика (обычно при переключениях 
    // выдача температуры 85 град не приводила к переходу на другой шаг программы
    Serial.println(T);
    timer=millis()/1000;         // текущее время в сек.
    
    if (running) {
    switch (process) {
      case 0:
        port1_stat=0;
        running=0;
        for ( i = 0; i < 5; i++) {
        tone(buzzer, 1000);
        delay(500);
        noTone(buzzer);
        delay(500);
        }
      break; 
     
      case 1:
     if (T<T1) {port1_stat=1;}
     else {
       port1_stat=0;
       process++;
       procStTime=timer;
     }
     break; 

     case 2:
     if (procStTime+P1*60 < timer) {process++;}
      else {
       port1_stat=0;
       if (T<T1) {port1_stat=1;}
     }
     break;
 
     case 3:
     if (T<T2) {port1_stat=1;}
     else {
       port1_stat=0;
       process++;
       procStTime=timer;
     }
     break;
 
     case 4:
     if (procStTime+P2*60 < timer) {process++;}
      else {
       port1_stat=0;
       if (T<T2) {port1_stat=1;}
     }
     break;
 
     case 5:
     if (T<T3) {port1_stat=1;}
     else {
       port1_stat=0;
       process++;
       procStTime=timer;
     }
     break;
 
     case 6:
     if (procStTime+P3*60 < timer) {process++;}
      else {
        port1_stat=0;
        if (T<T3) {port1_stat=1;}
    }
     break;
  
     case 7:
     if (T<T4) {port1_stat=1;}
     else {
       port1_stat=0;
       process++;
       procStTime=timer;
     }
     break;     
 
     case 8:
     if (procStTime+P4*60 < timer) {process=0;}
      else {
       port1_stat=0;
       if (T<T4) {port1_stat=1;}
     }
     break;     
    } 
    digitalWrite(port1, port1_stat);
    }
    Menu(0);
  
}

int button () {
    butPush = 0; // код нажатой кнопки
    exitMenu=1;  // переменная разрешающая продолжение цикла опроса
    tone(buzzer, 1000);
    while(exitMenu) {
    val = analogRead(butPin);  // читаем АЦП порта кнопок (значение от 0 до 1023)
    if (val > 183 && val < 223) {butPush = 5;}  
    if (val > 387 && val < 427) {butPush = 4;}
    if (val > 591 && val < 622) {butPush = 3;}
    if (val > 797 && val < 837) {butPush = 2;}
    if (val > 1000) {butPush = 1;}
    delay(10);  // задержка для устранения дребезга контактов
    if (val < 100 && butPush > 0) {exitMenu=0;} // если кнопка была нажата а затем отпущена,
    // то выходим из цикла опроса
    }
    noTone(buzzer);
  return butPush;
}

void printTimer () {
       if (process == 1 || process == 3 || process == 5 || process == 7) {
       lcd.print(" __:__"); }
       else {
          switch (process) {
           case 2:
           timer=P1*60+procStTime-timer;
           break; 
           case 4:
           timer=P2*60+procStTime-timer;
           break; 
           case 6:
           timer=P3*60+procStTime-timer;
           break; 
           case 8:
           timer=P4*60+procStTime-timer;
           break; 
          }
         n=timer/60;
         if (n < 100) lcd.print(" "); 
         if (n < 10) lcd.print(" "); 
         lcd.print(n,DEC);
         lcd.print(":"); 
         n=timer-(timer/60)*60;
         if (n < 10) lcd.print("0"); 
         lcd.print(n,DEC);    
       } 
}

void Menu(int butPush) {
    switch (menu) {
      case 0: // основной экран, показываем температуру, шаг, на котором находится программа, и  таймер
        lcd.clear();
        lcd.print("T=");
        lcd.print(T); // температура
        lcd.setCursor(13,0);
        if (port1_stat) {lcd.print("ON");} else  {lcd.print("OFF");}// состояние выхода нагрузки
        lcd.setCursor(0,1);
        switch (process) {
          case 0: {
        lcd.print("Stop"); 
        break;
          }
          case 1: {
        lcd.print("^"); 
        lcd.print(T1); 
        break;
          }
          case 2: {
        lcd.print("="); 
        lcd.print(T1); 
        break;
          }
          case 3: {
        lcd.print("^"); 
        lcd.print(T2); 
        break;
          }   
          case 4: {
        lcd.print("="); 
        lcd.print(T2); 
        break;
          }        
          case 5: {
        lcd.print("^"); 
        lcd.print(T3); 
        break;
          }
          case 6: {
        lcd.print("="); 
        lcd.print(T3); 
        break;
          }
          case 7: {
        lcd.print("^"); 
        lcd.print(T4); 
        break;
          }
          case 8: {
        lcd.print("="); 
        lcd.print(T4); 
        break;
          }
        }
        lcd.setCursor(10,1);
        printTimer();
        if (butPush == 1) {menu=9; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;

      case 1: // настройка первой паузы, температура
        lcd.clear();
        lcd.print("Pause 1 Temp:");
        lcd.setCursor(0,1);
        lcd.print(T1);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {T1--; Menu(0);}
        if (butPush == 4) {T1++; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;

      case 2: // настройка первой паузы, длительность
        lcd.clear();
        lcd.print("Pause 1 time:");
        lcd.setCursor(0,1);
        lcd.print(P1);
        lcd.print(":00");
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {P1--; Menu(0);}
        if (butPush == 4) {P1++; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;

      case 3: // настройка второй паузы, температура
        lcd.clear();
        lcd.print("Pause 2 Temp:");
        lcd.setCursor(0,1);
        lcd.print(T2);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {T2--; Menu(0);}
        if (butPush == 4) {T2++; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;

      case 4: // настройка второй паузы, длительность
        lcd.clear();
        lcd.print("Pause 2 time:");
        lcd.setCursor(0,1);
        lcd.print(P2);
        lcd.print(":00");
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {P2--; Menu(0);}
        if (butPush == 4) {P2++; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;      

      case 5: // настройка третьей паузы, температура
        lcd.clear();
        lcd.print("Pause 3 Temp:");
        lcd.setCursor(0,1);
        lcd.print(T3);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {T3--; Menu(0);}
        if (butPush == 4) {T3++; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;

      case 6: // настройка третьей паузы, длительность
        lcd.clear();
        lcd.print("Pause 3 time:");
        lcd.setCursor(0,1);
        lcd.print(P3);
        lcd.print(":00");
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {P3--; Menu(0);}
        if (butPush == 4) {P3++; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;      

      case 7: // настройка четвертой паузы, температура
        lcd.clear();
        lcd.print("Pause 4 Temp:");
        lcd.setCursor(0,1);
        lcd.print(T4);
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {T4--; Menu(0);}
        if (butPush == 4) {T4++; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;

      case 8: // настройка четвертой паузы, длительность
        lcd.clear();
        lcd.print("Pause 4 time:");
        lcd.setCursor(0,1);
        lcd.print(P4);
        lcd.print(":00");
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {P4--; Menu(0);}
        if (butPush == 4) {P4++; Menu(0);}
        if (butPush == 5) {menu++; Menu(0);}
      break;      

      case 9: // запуск процесса
        lcd.clear();
        if (process) {
          lcd.print("Process active");
          lcd.setCursor(0,1);
          timer=timer-StTime;
          lcd.print(timer/60);
          lcd.print(":"); 
          n=timer-(timer/60)*60;
          if (n < 10) lcd.print("0"); 
          lcd.print(n,DEC);   
         }
        else {lcd.print("Process stopped");}
        if (butPush == 1) {menu--; Menu(0);}
        if (butPush == 2) {process--; Menu(0);}
        if (butPush == 3) {
        if (running) {process=0; Menu(0);}
        else {running=1; process=1; StTime=timer;  Menu(0);}
    }
        if (butPush == 4) {process++; Menu(0);}
        if (butPush == 5) {menu=0; Menu(0);}
      break;      
    } // end switch

}

